import java.util.LinkedList;

public class DequeMethodsExample {
    public static void main(String[] args) {
        // Create a LinkedList as a Deque (Queue and Stack)
        LinkedList<String> deque = new LinkedList<>();
        
        // 1. Queue Operations (FIFO - First In, First Out)
        // Offer elements to the end of the queue
        deque.offer("Apple");
        deque.offer("Banana");
        deque.offer("Cherry");
        System.out.println("Queue after offers: " + deque);
        
        // Peek the first element (without removing it)
        System.out.println("Peek first: " + deque.peek());  // Apple
        
        // Poll the first element (removes and returns it)
        System.out.println("Poll first: " + deque.poll());  // Apple
        System.out.println("Queue after poll: " + deque);
        
        // Offer an element to the front of the queue
        deque.offerFirst("Pineapple");
        System.out.println("Queue after offering first: " + deque);
        
        // Poll the first element
        System.out.println("Poll first: " + deque.pollFirst());  // Pineapple
        System.out.println("Queue after polling first: " + deque);
        
        // 2. Stack Operations (LIFO - Last In, First Out)
        // Push elements onto the stack (to the front)
        deque.push("Orange");
        deque.push("Grapes");
        deque.push("Mango");
        System.out.println("Stack after pushes: " + deque);
        
        // Peek the top of the stack (without removing it)
        System.out.println("Peek top of stack: " + deque.peek());  // Mango
        
        // Pop the top element (removes and returns it)
        System.out.println("Pop top of stack: " + deque.pop());  // Mango
        System.out.println("Stack after pop: " + deque);
    }
}

