import java.util.LinkedList;

public class LinkedListMethodsExample {
    public static void main(String[] args) {
        // Create an empty LinkedList
        LinkedList<String> list = new LinkedList<>();
        
        // 1. Add elements to the LinkedList
        list.add("Apple");
        list.add("Banana");
        list.add("Cherry");
        System.out.println("After adding elements: " + list);
        
        // 2. Add element at a specific index
        list.add(1, "Blueberry");
        System.out.println("After adding Blueberry at index 1: " + list);
        
        // 3. Access elements using get(index)
        System.out.println("Element at index 2: " + list.get(2));  // Access "Cherry"
        
        // 4. Set (replace) an element at a specific index
        list.set(2, "Citrus");
        System.out.println("After setting index 2 to 'Citrus': " + list);
        
        // 5. Remove element by index
        list.remove(1);  // Removes "Blueberry" at index 1
        System.out.println("After removing element at index 1: " + list);
        
        // 6. Remove element by object (removes first occurrence of "Banana")
        list.remove("Banana");
        System.out.println("After removing 'Banana': " + list);
        
        // 7. Clear all elements
        list.clear();
        System.out.println("After clearing the list: " + list);
    }
}

