import java.util.LinkedList;
import java.util.ListIterator;

public class ListIteratorExample {
    public static void main(String[] args) {
        // Create a LinkedList and add elements
        LinkedList<String> list = new LinkedList<>();
        list.add("Apple");
        list.add("Banana");
        list.add("Cherry");
        list.add("Date");
        list.add("Elderberry");
        System.out.println("Original List: " + list);

        // 1. Create a ListIterator for the LinkedList
        ListIterator<String> listIterator = list.listIterator();

        // 2. Traverse the list forward (using hasNext() and next())
        System.out.println("Traversing forward:");
        while (listIterator.hasNext()) {
            System.out.println("Next: " + listIterator.next());
        }

        // 3. Traverse the list backward (using hasPrevious() and previous())
        System.out.println("\nTraversing backward:");
        while (listIterator.hasPrevious()) {
            System.out.println("Previous: " + listIterator.previous());
        }

        // 4. Modify an element using set()
        listIterator = list.listIterator();  // Reset iterator to the beginning
        while (listIterator.hasNext()) {
            String current = listIterator.next();
            if (current.equals("Banana")) {
                listIterator.set("Blueberry");  // Replace "Banana" with "Blueberry"
                System.out.println("Replaced 'Banana' with 'Blueberry'");
            }
        }
        System.out.println("List after modification: " + list);

        // 5. Add a new element using add()
        listIterator = list.listIterator();  // Reset iterator to the beginning
        while (listIterator.hasNext()) {
            String current = listIterator.next();
            if (current.equals("Cherry")) {
                listIterator.add("Coconut");  // Insert "Coconut" after "Cherry"
                System.out.println("Added 'Coconut' after 'Cherry'");
            }
        }
        System.out.println("List after adding 'Coconut': " + list);
    }
}

